"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = __importDefault(require("@twilio/flex-dev-utils/dist/lodash"));
var clients_1 = require("../clients");
var scripts_1 = require("./scripts");
var FlexPluginsAPIToolkitBase = /** @class */ (function () {
    function FlexPluginsAPIToolkitBase(httpClient) {
        var _this = this;
        // Clones the arguments before passing them to the script
        this.cloneArgs = function (script) {
            return function (option) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                return [2 /*return*/, script(lodash_1.default.cloneDeep(option))];
            }); }); };
        };
        var pluginClient = new clients_1.PluginsClient(httpClient);
        var pluginVersionsClient = new clients_1.PluginVersionsClient(httpClient);
        var configurationsClient = new clients_1.ConfigurationsClient(httpClient);
        var configuredPluginsClient = new clients_1.ConfiguredPluginsClient(httpClient);
        var releasesClient = new clients_1.ReleasesClient(httpClient);
        this.deploy = this.cloneArgs(scripts_1.deployScript(pluginClient, pluginVersionsClient));
        this.createConfiguration = this.cloneArgs(scripts_1.createConfigurationScript(pluginClient, pluginVersionsClient, configurationsClient, configuredPluginsClient, releasesClient));
        this.release = this.cloneArgs(scripts_1.releaseScript(releasesClient));
        this.listPlugins = this.cloneArgs(scripts_1.listPluginsScript(pluginClient, configuredPluginsClient, releasesClient));
        this.describePlugin = this.cloneArgs(scripts_1.describePluginScript(pluginClient, pluginVersionsClient, configuredPluginsClient, releasesClient));
        this.archivePlugin = this.cloneArgs(scripts_1.archivePlugin(pluginClient));
        this.listPluginVersions = this.cloneArgs(scripts_1.listPluginVersionsScript(pluginVersionsClient, configuredPluginsClient, releasesClient));
        this.describePluginVersion = this.cloneArgs(scripts_1.describePluginVersionScript(pluginClient, pluginVersionsClient, configuredPluginsClient, releasesClient));
        this.archivePluginVersion = this.cloneArgs(scripts_1.archivePluginVersion(pluginVersionsClient));
        this.listConfigurations = this.cloneArgs(scripts_1.listConfigurationsScript(configurationsClient, releasesClient));
        this.describeConfiguration = this.cloneArgs(scripts_1.describeConfigurationScript(configurationsClient, configuredPluginsClient, releasesClient));
        this.archiveConfiguration = this.cloneArgs(scripts_1.archiveConfiguration(configurationsClient));
        this.listReleases = this.cloneArgs(scripts_1.listReleasesScript(releasesClient));
        this.describeRelease = this.cloneArgs(scripts_1.describeReleaseScript(configurationsClient, configuredPluginsClient, releasesClient));
        this.diff = this.cloneArgs(scripts_1.diffScript(configurationsClient, configuredPluginsClient, releasesClient));
    }
    return FlexPluginsAPIToolkitBase;
}());
exports.default = FlexPluginsAPIToolkitBase;
//# sourceMappingURL=flexPluginsAPIToolkitBase.js.map